/// <reference types="node" />
import { Http2SecureServer, Http2Server } from "http2";
import EventEmitter = require("eventemitter3");
import express = require("express");
interface MiddlewareDefs {
    prepend: any | any[];
    append: any | any[];
}
declare class App {
    private static _instance;
    static readonly Instance: App;
    newInstance(): App;
    constructor();
    expressApp: express.Application;
    server: any;
    events: EventEmitter;
    on(eventName: string, callback: EventEmitter.ListenerFn): void;
    once(eventName: string, callback: EventEmitter.ListenerFn): void;
    off(eventName: string, callback: EventEmitter.ListenerFn): void;
    init(middlewares?: MiddlewareDefs): void;
    start(): Http2Server | Http2SecureServer;
    kill(): void;
    all(reqPath: string | RegExp | any[], ...callbacks: any[]): any;
    get(reqPath: string | RegExp | any[], ...callbacks: any[]): any;
    post(reqPath: string | RegExp | any[], ...callbacks: any[]): any;
    put(reqPath: string | RegExp | any[], ...callbacks: any[]): any;
    patch(reqPath: string | RegExp | any[], ...callbacks: any[]): any;
    delete(reqPath: string | RegExp | any[], ...callbacks: any[]): any;
    use(reqPath?: string, ...callbacks: any[]): any;
    route(reqPath: string): express.IRoute;
    renderView: (req: express.Request, res: express.Response, view: string, options?: any, status?: number) => void;
    renderText: (req: express.Request, res: express.Response, text: any, status?: number) => void;
    renderJson: (req: express.Request, res: express.Response, data: any, status?: number) => void;
    renderImage: (req: express.Request, res: express.Response, filename: string, options?: any) => void;
    renderError: (req: express.Request, res: express.Response, error: any, status?: string | number) => void;
}
declare const _default: App;
export = _default;
